<template>
  <div shadow="never" class="homeBoxCard">
    <div :style="'height:' + Height" id="sumeChartRef" ref="sumeChartRef" />
  </div>
</template>
<script>
import { computed, defineComponent, onMounted,  watch } from 'vue'
import { useStore } from 'vuex'
import * as echarts from 'echarts'
// import { ChartDataType } from "../../data";

export default defineComponent({
  name: 'CurveCom',
  props: {
    Height: String,
    echartsData: Object,
  },
  setup(props) {
    const store = useStore()

    // 总数
    const total = computed(() => store.state.Home.worksChartData.total)
    // num
    const num = computed(() => store.state.Home.worksChartData.num)

    // 读取数据 func

    const getData = async () => {
      console.log('ecahrts子组件中的props.ecahrtsData')
      console.log(props.echartsData)
    }

    function echarts2() {
      let myChart = echarts.init(document.getElementById('sumeChartRef'))

      // 绘制图表
      myChart.setOption({
        color: ['#FEB70D', '#50F335', '#0DC8FE'],
        tooltip: {
          trigger: 'axis',
        },
        toolbox: {
          show: true,
          feature: {
            // dataView: { show: true, readOnly: false },
            // magicType: { show: true, type: ["line", "bar"] },
            // restore: { show: true },
            saveAsImage: { show: true, color: 'black',title:'',name:'图表下载' },
          },
          iconStyle: {
            borderColor: '#666',
          },
          right: '10px',
        },
        // 图列组件
        legend: {
          itemHeight: 10, //改变圆圈大小
          itemWidth: 26, //改变圆圈大小
          itemGap: 30,
          textStyle: {
            color: 'black',
          },

          bottom: '0',
        },
        grid: {
          left: '3%',
          right: '4%',
          bottom: '5%',
          containLabel: true,
        },
        xAxis: {
          type: 'category',
          boundaryGap: true,
          data: props.echartsData.listDate.map((val) => {
            return val.split(':')[0]
          }),
          axisTick: {
            show: false, //去除刻度线
          },
          axisLabel: {
            color: 'black', // 文本颜色
          },
          axisLine: {
            show: false, // 去除轴线
          },
        },
        yAxis: {
          // name: 'kv',
          nameTextStyle: {
            color: 'black',
            fontSize: 10,
          },
          type: 'value',
          axisTick: {
            show: true, //去除刻度线
          },
          axisLabel: {
            color: 'black', // 文本颜色
          },
          axisLine: {
            show: true, // 去除轴线
            lineStyle: {
              color: 'black',
            },
          },
          splitNumber: 5,
          splitLine: {
            show: true,
            lineStyle: {
              color: '#9d9d9d',
            },
          },
        },
        series: [
          {
            name: '电量(kWh)',
            type: 'line',
            smooth: false,
            data: props.echartsData.list,
            symbolSize: 6,
            markPoint: {
              data: [
                { type: 'max', name: 'Max' },
                { type: 'min', name: 'Min' },
              ],
            },
          },
        ],
      })
      window.onresize = function () {
        // 自适应大小
        myChart.resize()
      }
    }

    onMounted(() => {
      // alert(1)
      getData()
      echarts2()
    })

    const writeValue = (val) => {
      val
      echarts2()
      getData()
    }

    //监听变化
    watch(
      () => props.echartsData,
      (newVal, oldVal, clear) => {
        // 执行异步任务，并得到关闭异步任务的 id

        // alert(1)
        console.log(newVal)
        let id = writeValue(newVal, oldVal)
        // 如果 watch 监听被重复执行了，则会先清除上次未完成的异步任务
        clear(() => clearTimeout(id))
      },
      { lazy: true }
    )

    return {
      total,
      num,
      echarts,
    }
  },
})
</script>
<style lang="scss" scoped>
.homeBoxCard {
  // margin-bottom: 24px;
  ::v-deep(.el-card__header) {
    padding-left: 12px;
    padding-right: 12px;
  }
  ::v-deep(.el-card__body) {
    padding: 12px;
    font-size: 14px;
    line-height: 1.5715;
  }
  ::v-deep(.el-divider) {
    margin: 8px 0;
  }
  .num {
    font-size: 30px;
    color: #515a6e;
  }
}
</style>